%define major	1
%define libname	%mklibname %{name} %{major}
%define devname	%mklibname %{name} -d
%define libfawk	%mklibname %{name}-fawk %{major}
%define liblua	%mklibname %{name}-lua %{major}
%define libmawk	%mklibname %{name}-mawk %{major}
%define libtcl	%mklibname %{name}-tcl %{major}
%define libpy3	%mklibname %{name}-python3 _%{major}
%define libdukt	%mklibname %{name}-duktape %{major}
%define libperl	%mklibname %{name}-perl %{major}
%define libcli	%mklibname %{name}-cli %{major}

Name:			fungw
Summary:		Standard installation of lib%{name}
Version:		1.2.1
Release:		%mkrel 8
Group:			Development/Tools
License:		GPLv2
Url:			http://www.repo.hu/projects/fungw
Source0:		http://www.repo.hu/projects/%{name}/releases/%{name}-%{version}.tar.gz
Patch1:			add-explicit-void-pointer-cast-for-perl-.patch

BuildRequires:	glibc
BuildRequires:	pkgconfig(lua)
BuildRequires:	perl-devel
BuildRequires:	libmawk-devel
BuildRequires:	pkgconfig(tcl)
BuildRequires:	pkgconfig(lua)
BuildRequires:	pkgconfig(python3)
BuildRequires:	pkgconfig(duktape)

Requires:		%{libname} = %{version}-%{release}
Requires:		%{libfawk} = %{version}-%{release}
Requires:		%{libcli} = %{version}-%{release}

%description
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs %{name} core and support for a few very small
scripting languages.

%files
# No files - meta package

#----------------------------
%package -n %{libname}
Summary:	Core %{name} library with the API

%description -n %{libname}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs %{name} core library that provides the API, but
does not contain any scripting language binding.

%files -n %{libname}
%{_docdir}/%{name}/
%{_usr}/lib/puplug/%{name}_c.*
%{_libdir}/lib%{name}.so{,.*}
%{_libdir}/lib%{name}_c.*

#----------------------------
%package -n %{devname}
Summary:	Core %{name} library with the API
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%files -n %{devname}
%{_libdir}/lib%{name}.so.%{major}
%{_includedir}/lib%{name}/

%description -n %{devname}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package contains all header files to allow applications to compile
with %{name}.

#---------------------------
%package -n %{libfawk}
Summary:	Scripting support for %{name}: fawk, fpas and fbas
Requires:	%{libname} = %{version}-%{release}

%description -n %{libfawk}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the interpreter and %{name} binding of fawk
(function-awk), fbas (function-BASIC) and fpas (function-PASCAL).

%files -n %{libfawk}
%{_libdir}/lib%{name}_fawk.*
%{_usr}/lib/puplug/%{name}_fawk.* 

#----------------------------
%package -n %{liblua}
Summary:	Scripting support for %{name}: lua
Requires:	%{libname} = %{version}-%{release}

%description -n %{liblua}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the language binding for lua.

%files -n %{liblua}
%{_libdir}/lib%{name}_lua.*
%{_usr}/lib/puplug/%{name}_lua.*

#----------------------------
%package -n %{libmawk}
Summary:	Scripting support for %{name}: mawk
Requires:	%{libname} = %{version}-%{release}

%description -n %{libmawk}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the language binding for mawk.

%files -n %{libmawk}
%{_libdir}/lib%{name}_mawk.*
%{_usr}/lib/puplug/%{name}_mawk.*

#--------------------------
%package -n %{libtcl}
Summary:	Scripting support for %{name}: tcl 
Requires:	%{libname} = %{version}-%{release}

%description -n %{libtcl}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the language binding for tcl.

%files -n %{libtcl}
%{_libdir}/lib%{name}_tcl.*
%{_usr}/lib/puplug/%{name}_tcl.*

#--------------------------
%package -n %{libpy3}
Summary:	Scripting support for %{name}: python3
Requires:	%{libname} = %{version}-%{release}

%description -n %{libpy3}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the language binding for python 3.

%files -n %{libpy3}
%{_libdir}/lib%{name}_python3.*
%{_usr}/lib/puplug/%{name}_python3.*

#---------------------------
%package -n %{libdukt}
Summary:	Dynamic library files for linking with %{name}
Requires:	%{libname} = %{version}-%{release}

%description -n %{libdukt}
Scripting support for %{name}: Javascript 

%files -n %{libdukt}
%{_libdir}/lib%{name}_duktape.*
%{_usr}/lib/puplug/%{name}_duktape.*

#---------------------------
%package -n %{libperl}
Summary:	Scripting support for %{name}: perl
Requires:	%{libname} = %{version}-%{release}

%description -n %{libperl}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the language binding for perl.

%files -n %{libperl}
%{_libdir}/lib%{name}_perl.*
%{_usr}/lib/puplug/%{name}_perl.*

#---------------------------
%package -n %{libcli}
Summary:	Scripting support for %{name}: external languages (bash)
Requires:	%{libname} = %{version}-%{release}

%description -n %{libcli}
Fungw is a tiny, portable library written in C (C89) that manages
dynamic function calls across different programming languages.

This package installs the binding to scripting languages ran as
an external process. Currently supported language is bash.

%files -n %{libcli}
%{_libdir}/lib%{name}_cli.*
%{_usr}/lib/puplug/%{name}_cli.*

%prep
%autosetup -p1

%build
%set_build_flags

./configure --prefix=%{_usr} --libdirname=%{_lib}
%make_build

%install
%make_install


%changelog
* Tue Mar 04 2025 wally <wally> 1.2.1-8.mga10
+ Revision: 2160365
- rebuild for python3.13

* Fri Aug 23 2024 daviddavid <daviddavid> 1.2.1-7.mga10
+ Revision: 2089949
- add debian patch to fix build with gcc 14
+ tv <tv>
- Rebuild for perl-5.40
+ barjac <barjac>
- rebuild for perl

* Tue Feb 06 2024 barjac <barjac> 1.2.1-5.mga10
+ Revision: 2037403
- rebuild for python

* Sun Dec 10 2023 barjac <barjac> 1.2.1-4.mga10
+ Revision: 2016866
- rebuild for perl

* Sat Dec 17 2022 wally <wally> 1.2.1-3.mga9
+ Revision: 1924419
- rebuild for duktape 2.7.0

* Mon Jun 06 2022 umeabot <umeabot> 1.2.1-2.mga9
+ Revision: 1861495
- Rebuild for Perl 5.36

* Mon Apr 25 2022 barjac <barjac> 1.2.1-1.mga9
+ Revision: 1853776
- new version 1.2.1
- really remove un-needed requires
- use full name in url

* Mon Apr 25 2022 barjac <barjac> 1.2.0-6.mga9
+ Revision: 1853726
- use %%set_build_flags

* Mon Apr 25 2022 barjac <barjac> 1.2.0-5.mga9
+ Revision: 1853709
- fix un-needed requires

* Tue Apr 12 2022 barjac <barjac> 1.2.0-4.mga9
+ Revision: 1848925
- rebuild for python-3.10

* Sat Mar 19 2022 umeabot <umeabot> 1.2.0-3.mga9
+ Revision: 1799210
- Mageia 9 Mass Rebuild

* Fri Feb 18 2022 barjac <barjac> 1.2.0-2.mga9
+ Revision: 1779553
- rebuild for python-3.10

* Wed Oct 20 2021 barjac <barjac> 1.2.0-1.mga9
+ Revision: 1752347
- new package fungw-1.2.0

